// NItestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NItest.h"
#include "NItestDlg.h"
#include "NIDAQmxBase.h"
#include ".\nitestdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CNItestDlg dialog



CNItestDlg::CNItestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNItestDlg::IDD, pParent)
	, edit_info(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNItestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, ListBox_ErrorMsg);
	DDX_Text(pDX, IDC_EDIT1, edit_info);
}

BEGIN_MESSAGE_MAP(CNItestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_TEST, OnBnClickedTest)
END_MESSAGE_MAP()


// CNItestDlg message handlers

BOOL CNItestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////
	//Start of test
	edit_info="Click on Test to Start";
	// Update the dialog
	UpdateData(FALSE);
	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNItestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNItestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNItestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CNItestDlg::OnBnClickedTest()
{
	// TODO: Add your control notification handler code here
	
	//Clear list box
	ListBox_ErrorMsg.ResetContent();
	//Start of test
	edit_info="Testing... Please wait!";
	// Update the dialog
	UpdateData(FALSE);
	//----------------------------------------------------------------------
	//Teste aos sinais Analgicos
	
	//Variable Inicialization
	int aerro[8] = {0, 0, 0, 0, 0, 0, 0, 0};
	int derro[8] = {0, 0, 0, 0, 0, 0, 0, 0};
	// Task parameters
	TaskHandle  taskHandle = 0;
	
	// Channel parameters
	CString     chan;
	float64     min;
	float64     max;

	// Timing parameters
	uInt64      samplesPerChan = 1;

	// Data write parameters
	float64     wdata;
	int32       pointsWritten;
	float64     timeout = 1.0;
	
	// Data read parameters
	float64     rdata;
	int32       pointsToRead = 1;
	int32       pointsRead;

	//Writing to AO - 0 to 5V test
	for (double i=1; i<6; i+=1) 	{
		//Output value
		wdata=i;

		// Channel parameters
		min = 0.0;
		max = 5.0;
		//channel AO - pin 14
		chan = "Dev1/ao0";

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAOVoltageChan(taskHandle,chan,"",min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseWriteAnalogF64(taskHandle,samplesPerChan,0,timeout,DAQmx_Val_GroupByChannel,&wdata,&pointsWritten,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);
		
		//channel AO - pin 15
		chan = "Dev1/ao1";

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAOVoltageChan(taskHandle,chan,"",min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseWriteAnalogF64(taskHandle,samplesPerChan,0,timeout,DAQmx_Val_GroupByChannel,&wdata,&pointsWritten,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);


		//Reading from AI:	ai2 pin8, ai6 pin9, ai3 pin11, ai7 pin12 - ligados ao ao0 pin 14
		//					ai0 pin2, ai4 pin3, ai1 pin5, ai4 pin6 - ligados ao ao1 pin 15

		// Channel parameters
		min = -10.0;
		max = 10.0;

		//channel ai0 - pin 2
		chan = "Dev1/ai0";

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAIVoltageChan(taskHandle,chan,"",DAQmx_Val_RSE,min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseReadAnalogF64(taskHandle,pointsToRead,timeout,DAQmx_Val_GroupByChannel,&rdata,samplesPerChan,&pointsRead,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		if (rdata<0.9*wdata || rdata>1.1*wdata)
			aerro[0]=1;
		
		//channel ai1 - pin 5
		chan = "Dev1/ai1";

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAIVoltageChan(taskHandle,chan,"",DAQmx_Val_RSE,min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseReadAnalogF64(taskHandle,pointsToRead,timeout,DAQmx_Val_GroupByChannel,&rdata,samplesPerChan,&pointsRead,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		if (rdata<0.9*wdata || rdata>1.1*wdata)
			aerro[1]=1;

		//channel ai2 - pin 8
		chan = "Dev1/ai2";

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAIVoltageChan(taskHandle,chan,"",DAQmx_Val_RSE,min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseReadAnalogF64(taskHandle,pointsToRead,timeout,DAQmx_Val_GroupByChannel,&rdata,samplesPerChan,&pointsRead,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		if (rdata<0.9*wdata || rdata>1.1*wdata)
			aerro[2]=1;

		//channel ai3 - pin 11
		chan = "Dev1/ai3";

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAIVoltageChan(taskHandle,chan,"",DAQmx_Val_RSE,min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseReadAnalogF64(taskHandle,pointsToRead,timeout,DAQmx_Val_GroupByChannel,&rdata,samplesPerChan,&pointsRead,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		if (rdata<0.9*wdata || rdata>1.1*wdata)
			aerro[3]=1;
		
		//channel ai4 - pin 3
		chan = "Dev1/ai4";

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAIVoltageChan(taskHandle,chan,"",DAQmx_Val_RSE,min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseReadAnalogF64(taskHandle,pointsToRead,timeout,DAQmx_Val_GroupByChannel,&rdata,samplesPerChan,&pointsRead,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		if (rdata<0.9*wdata || rdata>1.1*wdata)
			aerro[4]=1;
		
		//channel ai5 - pin 6
		chan = "Dev1/ai5";

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAIVoltageChan(taskHandle,chan,"",DAQmx_Val_RSE,min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseReadAnalogF64(taskHandle,pointsToRead,timeout,DAQmx_Val_GroupByChannel,&rdata,samplesPerChan,&pointsRead,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		if (rdata<0.9*wdata || rdata>1.1*wdata)
			aerro[5]=1;
	
		//channel ai6 - pin 9
		chan = "Dev1/ai6";

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAIVoltageChan(taskHandle,chan,"",DAQmx_Val_RSE,min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseReadAnalogF64(taskHandle,pointsToRead,timeout,DAQmx_Val_GroupByChannel,&rdata,samplesPerChan,&pointsRead,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		if (rdata<0.9*wdata || rdata>1.1*wdata)
			aerro[6]=1;
		
		//channel ai7 - pin 12
		chan = "Dev1/ai7";

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAIVoltageChan(taskHandle,chan,"",DAQmx_Val_RSE,min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseReadAnalogF64(taskHandle,pointsToRead,timeout,DAQmx_Val_GroupByChannel,&rdata,samplesPerChan,&pointsRead,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		if (rdata<0.9*wdata || rdata>1.1*wdata)
			aerro[7]=1;
	}// end cycle for
		
	//Analog Error verification
	if (aerro[0]==1)
		ListBox_ErrorMsg.AddString("Analog connection error:  pin15 - pin2");
	if (aerro[1]==1)
		ListBox_ErrorMsg.AddString("Analog connection error:  pin15 - pin5");
	if (aerro[2]==1)
		ListBox_ErrorMsg.AddString("Analog connection error:  pin14 - pin8");
	if (aerro[3]==1)
		ListBox_ErrorMsg.AddString("Analog connection error:  pin14 - pin11");
	if (aerro[4]==1)
		ListBox_ErrorMsg.AddString("Analog connection error:  pin15 - pin3");
	if (aerro[5]==1)
		ListBox_ErrorMsg.AddString("Analog connection error:  pin15 - pin6");
	if (aerro[6]==1)
		ListBox_ErrorMsg.AddString("Analog connection error:  pin14 - pin9");
	if (aerro[7]==1)
		ListBox_ErrorMsg.AddString("Analog connection error:  pin14 - pin12");


	//Teste aos sinais Digitais----------------------------------------------

	// Write parameters
	uInt8       w_data [1];
	int32       written;
	// Read parameters
	uInt8      r_data [1];
	int32       read;

	//pins 25, 26, 27, 28 - Output all 0 Volts - Test all digital outputs 0
	// Channel parameters
	chan = "Dev1/port1";
	// Create Digital Output (DO) Task and Channel
	DAQmxBaseCreateTask ("", &taskHandle);
	DAQmxBaseCreateDOChan(taskHandle,chan,"",DAQmx_Val_ChanForAllLines);
	w_data[0] = 0x0;
	DAQmxBaseWriteDigitalU8(taskHandle,1,1,10.0,DAQmx_Val_GroupByChannel,w_data,&written,NULL);
	DAQmxBaseStopTask (taskHandle);
	DAQmxBaseClearTask (taskHandle);

	
	//pins 17 to 24 - Input
	// Channel parameters
	chan = "Dev1/port0";
	// Create Digital Input (DI) Task and Channel
	DAQmxBaseCreateTask ("", &taskHandle);
	DAQmxBaseCreateDIChan(taskHandle,chan,"",DAQmx_Val_ChanForAllLines);
	// Start Task (configure port)
	DAQmxBaseStartTask (taskHandle);
	// Read from port
	DAQmxBaseReadDigitalU8(taskHandle,1,10.0,DAQmx_Val_GroupByChannel,r_data,1,&read,NULL);
	DAQmxBaseStopTask (taskHandle);
	DAQmxBaseClearTask (taskHandle);

	int	teste=(int)r_data[0];
	// convert int (0 to 255) to CString (8 bits binary)
	CString bin = "";
	for(int i=128;i>0;i/=2) {
		if(i<=teste) {
			bin.Append("1");
			teste-=i;
		}
		else
			bin.Append("0");
	}

	//If any of the readings is 1 --> error
	if ((bin[0]-'0')==1)
		derro[0]=1;
	if ((bin[1]-'0')==1)
		derro[1]=1;
	if ((bin[2]-'0')==1)
		derro[2]=1;
	if ((bin[3]-'0')==1)
		derro[3]=1;
	if ((bin[4]-'0')==1)
		derro[4]=1;
	if ((bin[5]-'0')==1)
		derro[5]=1;
	if ((bin[6]-'0')==1)
		derro[6]=1;
	if ((bin[7]-'0')==1)
		derro[7]=1;


	//pins 25, 26, 27, 28 - Output all 5 Volts - test all digital outputs 1
	// Channel parameters
	chan = "Dev1/port1";
	// Create Digital Output (DO) Task and Channel
	DAQmxBaseCreateTask ("", &taskHandle);
	DAQmxBaseCreateDOChan(taskHandle,chan,"",DAQmx_Val_ChanForAllLines);
	w_data[0] = 0xF;
	DAQmxBaseWriteDigitalU8(taskHandle,1,1,10.0,DAQmx_Val_GroupByChannel,w_data,&written,NULL);
	DAQmxBaseStopTask (taskHandle);
	DAQmxBaseClearTask (taskHandle);

	
	//pins 17 to 24 - Input
	// Channel parameters
	chan = "Dev1/port0";
	// Create Digital Input (DI) Task and Channel
	DAQmxBaseCreateTask ("", &taskHandle);
	DAQmxBaseCreateDIChan(taskHandle,chan,"",DAQmx_Val_ChanForAllLines);
	// Start Task (configure port)
	DAQmxBaseStartTask (taskHandle);
	// Read from port
	DAQmxBaseReadDigitalU8(taskHandle,1,10.0,DAQmx_Val_GroupByChannel,r_data,1,&read,NULL);
	DAQmxBaseStopTask (taskHandle);
	DAQmxBaseClearTask (taskHandle);

	teste=(int)r_data[0];
	
	// convert int (0 to 255) to CString (8 bits binary)
	bin = "";
	for(int i=128;i>0;i/=2) {
		if(i<=teste) {
			bin.Append("1");
			teste-=i;
		}
		else
			bin.Append("0");
	}

	//If any of the readings is 1 --> error
	if ((bin[0]-'0')==0)
		derro[0]=1;
	if ((bin[1]-'0')==0)
		derro[1]=1;
	if ((bin[2]-'0')==0)
		derro[2]=1;
	if ((bin[3]-'0')==0)
		derro[3]=1;
	if ((bin[4]-'0')==0)
		derro[4]=1;
	if ((bin[5]-'0')==0)
		derro[5]=1;
	if ((bin[6]-'0')==0)
		derro[6]=1;
	if ((bin[7]-'0')==0)
		derro[7]=1;

	//Digital Error verification
	if (derro[0]==1)
		ListBox_ErrorMsg.AddString("digital connection error:  pin25 - pin24");
	if (derro[1]==1)
		ListBox_ErrorMsg.AddString("digital connection error:  pin25 - pin23");
	if (derro[2]==1)
		ListBox_ErrorMsg.AddString("digital connection error:  pin26 - pin22");
	if (derro[3]==1)
		ListBox_ErrorMsg.AddString("digital connection error:  pin26 - pin21");
	if (derro[4]==1)
		ListBox_ErrorMsg.AddString("digital connection error:  pin27 - pin20");
	if (derro[5]==1)
		ListBox_ErrorMsg.AddString("digital connection error:  pin27 - pin19");
	if (derro[6]==1)
		ListBox_ErrorMsg.AddString("digital connection error:  pin28 - pin18");
	if (derro[7]==1)
		ListBox_ErrorMsg.AddString("digital connection error:  pin28 - pin17");


	if (aerro[0]==0 & aerro[1]==0 & aerro[2]==0 & aerro[3]==0 & aerro[4]==0 & aerro[5]==0 & aerro[6]==0 & aerro[7]==0 & derro[0]==0 & derro[1]==0 & derro[2]==0 & derro[3]==0 & derro[4]==0 & derro[5]==0 & derro[6]==0 & derro[7]==0)
		ListBox_ErrorMsg.AddString("Test OK!!!");


	//end of test
	edit_info="Test Completed";
	// Update the dialog
	UpdateData(FALSE);
	/*
	edit_do=(int)r_data[0];
	Binary=bin;
	// Update the dialog
	UpdateData(FALSE);
*/
}
